((Drupal, drupalSettings) => {
  Drupal.behaviors.diffPlusRawHtml = {
    attach: context => {

      const diff_preview = context.querySelector('[data-diff-plus-preview]');
      if (diff_preview) {
        const highlight_style = drupalSettings.diff_plus.highlight_style;

        document.getElementsByTagName('head')[0].appendChild(Object.assign(
          document.createElement('link'), {
            rel: 'stylesheet',
            href: 'https://cdnjs.cloudflare.com/ajax/libs/highlight.js/11.7.0/styles/' + highlight_style,
          }
        ));

        const diff_name = drupalSettings.diff_plus.diff_name;
        const left_revision = drupalSettings.diff_plus.left_revision;
        const right_revision = drupalSettings.diff_plus.right_revision;
        const beautify_options = drupalSettings.diff_plus.beautify_options;
        const ui_options = drupalSettings.diff_plus.ui_options;
        const left_text = html_beautify(left_revision, beautify_options);
        const right_text = html_beautify(right_revision, beautify_options);

        const patch = Diff.createPatch(diff_name, left_text, right_text);
        const diff_ui = new Diff2HtmlUI(diff_preview, patch, ui_options);

        diff_ui.draw();
        diff_ui.highlightCode();
      }
    }
  };
})(Drupal, drupalSettings);
